# -*- coding: utf-8 -*-

import threading
import os
import time

#
#
class CnvThread(threading.Thread):
    '''
    FFMPEGでFLVをMP3に変換させるスレッド
    '''
    def __init__(self, pathList):
        '''
        初期化
        '''
        threading.Thread.__init__(self)
        self.uniPathList = pathList

    def run(self):
        '''
        スレッド処理
        '''
        for path in self.uniPathList:
            if os.path.isfile(path) == False:
                continue

            args = ('ffmpeg',
                    '-y',
                    '-i', path,
                    '-ab', '128',
                    '-ar', '44100',
                    '-ac', '2',
                    path + '.mp3')
            
            os.spawnvp(os.P_WAIT, 'ffmpeg', args)
            time.sleep(0.02)
