# -*- coding: utf-8 -*-

import sys
import os.path
import pygtk

if sys.platform != 'win32':
    pygtk.require('2.0')

import gtk
gtk.gdk.threads_init()
    
from cnvThread import CnvThread

#
#
class MainWindow:
    '''
    メインウインドウ
    '''
    DND_TARGET_TYPE_URI_LIST = 100
    
    def __init__(self):
        '''
        初期化
        '''
        self.wind = gtk.Window(gtk.WINDOW_TOPLEVEL)        
        self.wind.set_size_request(300, 200)
        self.wind.set_border_width(10)
        self.wind.connect('destroy', self.on_destroy)
        
        self.frame = gtk.Frame('Drop FLV files here.')

        # フレームに対するファイルDnD設定
        dndTargetList = [('text/uri-list',
                          0,
                          self.DND_TARGET_TYPE_URI_LIST)]

        dndDestFlag = (gtk.DEST_DEFAULT_MOTION | 
                       gtk.DEST_DEFAULT_HIGHLIGHT | 
                       gtk.DEST_DEFAULT_DROP)

        dndAction = gtk.gdk.ACTION_COPY

        self.frame.connect('drag_data_received',
                            self.on_drag_data_received)
        self.frame.drag_dest_set(dndDestFlag,
                                 dndTargetList,
                                 dndAction)

        self.wind.add(self.frame)
        
        self.wind.show_all()

    def on_destroy(self, widget, event=None):
        '''
        ウィンドウ破棄時の処理
        '''
        print '--- quit ---'
        gtk.main_quit()

    def conv_to_path(self, urlStr):
        '''
        URL文字列からパス文字列に変換
        '''
        if urlStr == None or len(urlStr) == 0:
            return ''

        offset = 7
        if sys.platform == 'win32':
            offset = 8
        return urlStr[7:]
    
    def on_drag_data_received(self, i_widget, i_context, x, y,
                              selection_data, info, timestamp):
        '''
        ビューにドラッグ＆ドロップされた場合の処理
        '''
        if info != self.DND_TARGET_TYPE_URI_LIST:
            return

        # 複数ファイルがドロップされる可能性があるので、
        # パス文字列を分割しておく
        pathList = selection_data.data.split()
        uniPathList = map(lambda a: self.conv_to_path(a).decode('utf-8'), pathList)

        # 変換用のスレッドを生成して処理を開始
        ffmpegThread = CnvThread(uniPathList)
        ffmpegThread.start()

#
#
if __name__ == '__main__':
    # メインウインドウを生成
    wind = MainWindow()

    # GTKのイベントループを開始
    gtk.gdk.threads_enter()
    gtk.main()
    gtk.gdk.threads_leave()
    
